@echo off
cd /d "%~dp0"
setlocal enableextensions enabledelayedexpansion
echo.
set "syspath=%windir%\system32"
if exist "%windir%\sysnative\cmd.exe" (set "syspath=%windir%\sysnative")
set "PATH=%cd%;%syspath%;%windir%;%syspath%\Wbem;%syspath%\WindowsPowerShell\v1.0\"
set "xOS=x64"
if /i "%PROCESSOR_ARCHITECTURE%"=="x86" if not defined PROCESSOR_ARCHITEW6432 set "xOS=x86"

set "reg=%syspath%\reg.exe"
set "schtasks=%syspath%\schtasks.exe"
set "timeout=%syspath%\timeout.exe"
"%reg%" add "HKCU\Software\Microsoft\Windows Script Host\Settings" /v "Enabled" /t REG_DWORD /d "1" /f >nul 2>nul

"%reg%" query "HKU\S-1-5-19" >nul 2>nul || (
	echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\GetAdmin.vbs"
	echo UAC.ShellExecute "%~nx0", "%*", "", "runas", 1 >> "%temp%\GetAdmin.vbs"
	cscript //NOLOGO "%temp%\GetAdmin.vbs"
	del /f /q "%temp%\GetAdmin.vbs" >nul 2>&1
	exit
)

color 1f
title Remove Telemetry Office 2016\2019

set ExitOnComplete=0

rem Parse passed arguments to script
:parse_passed_params
  if "%~1"=="" goto end_parse_passed_params
  if /i "%~1"=="-e"        set ExitOnComplete=1
  if /i "%~1"=="-exit"     set ExitOnComplete=1
  if /i "%~1"=="/e"        set ExitOnComplete=1
  if /i "%~1"=="/exit"     set ExitOnComplete=1
  shift & goto parse_passed_params
:end_parse_passed_params

echo.
echo ================== DISABLE ACQUISITION OF TELEMETRY DATA ===================
echo.
echo Scheduler:  5 Office Telemetry related Tasks were set / changed
rem "%schtasks%" /Change /TN "Microsoft\Office\Office Automatic Updates" /Disable >nul 2>&1
rem "%schtasks%" /Change /TN "Microsoft\Office\Office Automatic Updates 2.0" /Disable >nul 2>&1
"%schtasks%" /Change /TN "Microsoft\Office\OfficeTelemetryAgentFallBack" /Disable >nul 2>&1
"%schtasks%" /Change /TN "Microsoft\Office\OfficeTelemetryAgentLogOn" /Disable >nul 2>&1
"%schtasks%" /Change /TN "Microsoft\Office\OfficeTelemetryAgentFallBack2016" /Disable >nul 2>&1
"%schtasks%" /Change /TN "Microsoft\Office\OfficeTelemetryAgentLogOn2016" /Disable >nul 2>&1
"%schtasks%" /Change /TN "Microsoft\Office\Office ClickToRun Service Monitor" /Disable >nul 2>&1

for /f "delims=" %%A in ('"wmic.exe path Win32_UserAccount where (Disabled='False' and Status='OK') get sid /Value" 2^>nul') do for /f "tokens=2 delims==" %%B in ("%%A") do (call :RegistryUser "%%B")

echo.
echo Registry:  23 Office Telemetry related Machine Group Policies were set / changed
"%reg%" add HKLM\Software\Microsoft\Office\Common\ClientTelemetry /v DisableTelemetry /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Common /v qmenable /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Common /v updatereliabilitydata /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Common\General /v shownfirstrunoptin /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Common\General /v skydrivesigninoption /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Common\ptwatson /v ptwoptin /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\Firstrun /v disablemovie /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM /v Enablelogging /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM /v EnableUpload /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM /v EnableFileObfuscation /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v accesssolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v olksolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v onenotesolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v pptsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v projectsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v publishersolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v visiosolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v wdsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedapplications /v xlsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v agave /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v appaddins /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v comaddins /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v documentfiles /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKLM\Software\Policies\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v templatefiles /t REG_DWORD /d 1 /f >nul 2>&1
echo.
  if %ExitOnComplete%==0 (
	echo Exit after 20 seconds, or press any key for exit now
	"%timeout%" /t 20 >nul 2>&1
	)
endlocal
echo on
goto :EOF

:RegistryUser
set "sid_user=%~1"
echo.
echo Registry:  29 Office Telemetry related User Keys for SID=%sid_user% were set / changed
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\Common\ClientTelemetry /v DisableTelemetry /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common /v sendcustomerdata /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common /v qmenable /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common /v updatereliabilitydata /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common\Feedback /v enabled /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common\Feedback /v includescreenshot /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common\General /v shownfirstrunoptin /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common\General /v skydrivesigninoption /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Common\ptwatson /v ptwoptin /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Outlook\Options\Mail /v EnableLogging /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Word\Options /v EnableLogging /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\Firstrun /v disablemovie /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM /v Enablelogging /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM /v EnableUpload /t REG_DWORD /d 0 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM /v EnableFileObfuscation /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v accesssolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v olksolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v onenotesolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v pptsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v projectsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v publishersolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v visiosolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v wdsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedapplications /v xlsolution /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v agave /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v appaddins /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v comaddins /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v documentfiles /t REG_DWORD /d 1 /f >nul 2>&1
"%reg%" add HKEY_USERS\%sid_user%\Software\Microsoft\Office\16.0\OSM\preventedsolutiontypes /v templatefiles /t REG_DWORD /d 1 /f >nul 2>&1
goto :EOF
